// Package v2 provides primitives to interact with the openapi HTTP API.
//
// Code generated by github.com/deepmap/oapi-codegen version v1.8.2 DO NOT EDIT.
package v2

import (
	"bytes"
	"compress/gzip"
	"encoding/base64"
	"fmt"
	"net/http"
	"net/url"
	"path"
	"strings"

	"github.com/deepmap/oapi-codegen/pkg/runtime"
	"github.com/getkin/kin-openapi/openapi3"
	"github.com/labstack/echo/v4"
)

const (
	BearerScopes = "Bearer.Scopes"
)

// Defines values for AzureUploadOptionsHyperVGeneration.
const (
	AzureUploadOptionsHyperVGenerationV1 AzureUploadOptionsHyperVGeneration = "V1"

	AzureUploadOptionsHyperVGenerationV2 AzureUploadOptionsHyperVGeneration = "V2"
)

// Defines values for BlueprintCustomizationsPartitioningMode.
const (
	BlueprintCustomizationsPartitioningModeAutoLvm BlueprintCustomizationsPartitioningMode = "auto-lvm"

	BlueprintCustomizationsPartitioningModeLvm BlueprintCustomizationsPartitioningMode = "lvm"

	BlueprintCustomizationsPartitioningModeRaw BlueprintCustomizationsPartitioningMode = "raw"
)

// Defines values for ComposeStatusValue.
const (
	ComposeStatusValueFailure ComposeStatusValue = "failure"

	ComposeStatusValuePending ComposeStatusValue = "pending"

	ComposeStatusValueSuccess ComposeStatusValue = "success"
)

// Defines values for CustomizationsPartitioningMode.
const (
	CustomizationsPartitioningModeAutoLvm CustomizationsPartitioningMode = "auto-lvm"

	CustomizationsPartitioningModeLvm CustomizationsPartitioningMode = "lvm"

	CustomizationsPartitioningModeRaw CustomizationsPartitioningMode = "raw"
)

// Defines values for ImageSBOMPipelinePurpose.
const (
	ImageSBOMPipelinePurposeBuildroot ImageSBOMPipelinePurpose = "buildroot"

	ImageSBOMPipelinePurposeImage ImageSBOMPipelinePurpose = "image"
)

// Defines values for ImageSBOMSbomType.
const (
	ImageSBOMSbomTypeSpdx ImageSBOMSbomType = "spdx"
)

// Defines values for ImageStatusValue.
const (
	ImageStatusValueBuilding ImageStatusValue = "building"

	ImageStatusValueFailure ImageStatusValue = "failure"

	ImageStatusValuePending ImageStatusValue = "pending"

	ImageStatusValueRegistering ImageStatusValue = "registering"

	ImageStatusValueSuccess ImageStatusValue = "success"

	ImageStatusValueUploading ImageStatusValue = "uploading"
)

// Defines values for ImageTypes.
const (
	ImageTypesAws ImageTypes = "aws"

	ImageTypesAwsHaRhui ImageTypes = "aws-ha-rhui"

	ImageTypesAwsRhui ImageTypes = "aws-rhui"

	ImageTypesAwsSapRhui ImageTypes = "aws-sap-rhui"

	ImageTypesAzure ImageTypes = "azure"

	ImageTypesAzureEap7Rhui ImageTypes = "azure-eap7-rhui"

	ImageTypesAzureRhui ImageTypes = "azure-rhui"

	ImageTypesAzureSapRhui ImageTypes = "azure-sap-rhui"

	ImageTypesEdgeCommit ImageTypes = "edge-commit"

	ImageTypesEdgeContainer ImageTypes = "edge-container"

	ImageTypesEdgeInstaller ImageTypes = "edge-installer"

	ImageTypesGcp ImageTypes = "gcp"

	ImageTypesGcpRhui ImageTypes = "gcp-rhui"

	ImageTypesGuestImage ImageTypes = "guest-image"

	ImageTypesImageInstaller ImageTypes = "image-installer"

	ImageTypesIotBootableContainer ImageTypes = "iot-bootable-container"

	ImageTypesIotCommit ImageTypes = "iot-commit"

	ImageTypesIotContainer ImageTypes = "iot-container"

	ImageTypesIotInstaller ImageTypes = "iot-installer"

	ImageTypesIotRawImage ImageTypes = "iot-raw-image"

	ImageTypesIotSimplifiedInstaller ImageTypes = "iot-simplified-installer"

	ImageTypesLiveInstaller ImageTypes = "live-installer"

	ImageTypesMinimalRaw ImageTypes = "minimal-raw"

	ImageTypesOci ImageTypes = "oci"

	ImageTypesVsphere ImageTypes = "vsphere"

	ImageTypesVsphereOva ImageTypes = "vsphere-ova"

	ImageTypesWsl ImageTypes = "wsl"
)

// Defines values for UploadStatusValue.
const (
	UploadStatusValueFailure UploadStatusValue = "failure"

	UploadStatusValuePending UploadStatusValue = "pending"

	UploadStatusValueRunning UploadStatusValue = "running"

	UploadStatusValueSuccess UploadStatusValue = "success"
)

// Defines values for UploadTypes.
const (
	UploadTypesAws UploadTypes = "aws"

	UploadTypesAwsS3 UploadTypes = "aws.s3"

	UploadTypesAzure UploadTypes = "azure"

	UploadTypesContainer UploadTypes = "container"

	UploadTypesGcp UploadTypes = "gcp"

	UploadTypesLocal UploadTypes = "local"

	UploadTypesOciObjectstorage UploadTypes = "oci.objectstorage"

	UploadTypesPulpOstree UploadTypes = "pulp.ostree"
)

// AWSEC2CloneCompose defines model for AWSEC2CloneCompose.
type AWSEC2CloneCompose struct {
	Region            string    `json:"region"`
	ShareWithAccounts *[]string `json:"share_with_accounts,omitempty"`
}

// AWSEC2UploadOptions defines model for AWSEC2UploadOptions.
type AWSEC2UploadOptions struct {
	Region            string   `json:"region"`
	ShareWithAccounts []string `json:"share_with_accounts"`
	SnapshotName      *string  `json:"snapshot_name,omitempty"`
}

// AWSEC2UploadStatus defines model for AWSEC2UploadStatus.
type AWSEC2UploadStatus struct {
	Ami    string `json:"ami"`
	Region string `json:"region"`
}

// AWSS3UploadOptions defines model for AWSS3UploadOptions.
type AWSS3UploadOptions struct {
	// If set to false (the default value), a long, obfuscated URL
	// is returned. Its expiration might be sooner than for other upload
	// targets.
	//
	// If set to true, a shorter URL is returned and
	// its expiration is the same as for the other upload targets.
	Public *bool  `json:"public,omitempty"`
	Region string `json:"region"`
}

// AWSS3UploadStatus defines model for AWSS3UploadStatus.
type AWSS3UploadStatus struct {
	Url string `json:"url"`
}

// AzureUploadOptions defines model for AzureUploadOptions.
type AzureUploadOptions struct {
	// Choose the VM Image HyperV generation, different features on Azure are available
	// depending on the HyperV generation.
	HyperVGeneration *AzureUploadOptionsHyperVGeneration `json:"hyper_v_generation,omitempty"`

	// Name of the uploaded image. It must be unique in the given resource group.
	// If name is omitted from the request, a random one based on a UUID is
	// generated.
	ImageName *string `json:"image_name,omitempty"`

	// Location of the provided resource_group, where the image should be uploaded and registered.
	// How to list all locations:
	// https://docs.microsoft.com/en-us/cli/azure/account?view=azure-cli-latest#az_account_list_locations'
	// If the location is not specified, it is deducted from the provided resource_group.
	Location *string `json:"location,omitempty"`

	// Name of the resource group where the image should be uploaded.
	ResourceGroup string `json:"resource_group"`

	// ID of subscription where the image should be uploaded.
	SubscriptionId string `json:"subscription_id"`

	// ID of the tenant where the image should be uploaded.
	// How to find it in the Azure Portal:
	// https://docs.microsoft.com/en-us/azure/active-directory/fundamentals/active-directory-how-to-find-tenant
	TenantId string `json:"tenant_id"`
}

// Choose the VM Image HyperV generation, different features on Azure are available
// depending on the HyperV generation.
type AzureUploadOptionsHyperVGeneration string

// AzureUploadStatus defines model for AzureUploadStatus.
type AzureUploadStatus struct {
	ImageName string `json:"image_name"`
}

// Blueprint defines model for Blueprint.
type Blueprint struct {
	// Container images to embed into the final artfact
	Containers     *[]Container             `json:"containers,omitempty"`
	Customizations *BlueprintCustomizations `json:"customizations,omitempty"`
	Description    *string                  `json:"description,omitempty"`

	// The distribution to use for the compose. If left empty the host
	// distro will be used.
	Distro *string `json:"distro,omitempty"`

	// Package groups to be installed
	Groups *[]PackageGroup `json:"groups,omitempty"`

	// An alias for packages, retained for backwards compatability
	Modules *[]Package `json:"modules,omitempty"`
	Name    string     `json:"name"`

	// Packages to be installed
	Packages *[]Package `json:"packages,omitempty"`

	// A semver version number
	Version *string `json:"version,omitempty"`
}

// BlueprintCustomizations defines model for BlueprintCustomizations.
type BlueprintCustomizations struct {
	Cacerts *CACertsCustomization `json:"cacerts,omitempty"`

	// Directories to create in the final artifact
	Directories *[]Directory `json:"directories,omitempty"`

	// FIDO device onboard configuration
	Fdo *FDO `json:"fdo,omitempty"`

	// Files to create in the final artifact
	Files *[]BlueprintFile `json:"files,omitempty"`

	// List of filesystem mountpoints to create
	Filesystem *[]BlueprintFilesystem `json:"filesystem,omitempty"`

	// Enable FIPS mode
	Fips *bool `json:"fips,omitempty"`

	// Firewalld configuration
	Firewall *BlueprintFirewall `json:"firewall,omitempty"`

	// List of groups to create
	Group *[]Group `json:"group,omitempty"`

	// Configures the hostname
	Hostname *string `json:"hostname,omitempty"`

	// Ignition configuration
	Ignition *Ignition `json:"ignition,omitempty"`

	// Name of the installation device, currently only useful for the edge-simplified-installer type
	InstallationDevice *string    `json:"installation_device,omitempty"`
	Installer          *Installer `json:"installer,omitempty"`
	Kernel             *Kernel    `json:"kernel,omitempty"`

	// Locale configuration
	Locale   *Locale            `json:"locale,omitempty"`
	Openscap *BlueprintOpenSCAP `json:"openscap,omitempty"`

	// Select how the disk image will be partitioned. 'auto-lvm' will use raw unless
	// there are one or more mountpoints in which case it will use LVM. 'lvm' always
	// uses LVM, even when there are no extra mountpoints. 'raw' uses raw partitions
	// even when there are one or more mountpoints.
	PartitioningMode *BlueprintCustomizationsPartitioningMode `json:"partitioning_mode,omitempty"`

	// Repositories to write to /etc/yum.repos.d/ in the final image. Note
	// that these are not used at build time.
	Repositories *[]BlueprintRepository `json:"repositories,omitempty"`
	Rhsm         *RHSMCustomization     `json:"rhsm,omitempty"`
	Rpm          *RPMCustomization      `json:"rpm,omitempty"`
	Services     *Services              `json:"services,omitempty"`

	// List of ssh keys
	Sshkey *[]SSHKey `json:"sshkey,omitempty"`

	// Timezone configuration
	Timezone *Timezone `json:"timezone,omitempty"`

	// List of users to create
	User *[]BlueprintUser `json:"user,omitempty"`
}

// Select how the disk image will be partitioned. 'auto-lvm' will use raw unless
// there are one or more mountpoints in which case it will use LVM. 'lvm' always
// uses LVM, even when there are no extra mountpoints. 'raw' uses raw partitions
// even when there are one or more mountpoints.
type BlueprintCustomizationsPartitioningMode string

// A custom file to create in the final artifact.
type BlueprintFile struct {
	// Contents of the file as plain text
	Data *string `json:"data,omitempty"`

	// Group of the file as a gid or a group name
	Group *interface{} `json:"group,omitempty"`

	// Permissions string for the file in octal format
	Mode *string `json:"mode,omitempty"`

	// Path to the file
	Path string `json:"path"`

	// Owner of the file as a uid or a user name
	User *interface{} `json:"user,omitempty"`
}

// BlueprintFilesystem defines model for BlueprintFilesystem.
type BlueprintFilesystem struct {
	// size of the filesystem in bytes
	Minsize    uint64 `json:"minsize"`
	Mountpoint string `json:"mountpoint"`
}

// Firewalld configuration
type BlueprintFirewall struct {
	// List of ports (or port ranges) and protocols to open
	Ports *[]string `json:"ports,omitempty"`

	// Firewalld services to enable or disable
	Services *FirewallServices `json:"services,omitempty"`
	Zones    *[]FirewallZones  `json:"zones,omitempty"`
}

// BlueprintOpenSCAP defines model for BlueprintOpenSCAP.
type BlueprintOpenSCAP struct {
	Datastream    *string                `json:"datastream,omitempty"`
	JsonTailoring *OpenSCAPJSONTailoring `json:"json_tailoring,omitempty"`

	// Puts a specified policy ID in the RHSM facts, so that any instances registered to
	// insights will be automatically connected to the compliance policy in the console.
	PolicyId  *string            `json:"policy_id,omitempty"`
	ProfileId string             `json:"profile_id"`
	Tailoring *OpenSCAPTailoring `json:"tailoring,omitempty"`
}

// BlueprintRepository defines model for BlueprintRepository.
type BlueprintRepository struct {
	Baseurls   *[]string `json:"baseurls,omitempty"`
	Enabled    *bool     `json:"enabled,omitempty"`
	Filename   *string   `json:"filename,omitempty"`
	Gpgcheck   *bool     `json:"gpgcheck,omitempty"`
	Gpgkeys    *[]string `json:"gpgkeys,omitempty"`
	Id         string    `json:"id"`
	Metalink   *string   `json:"metalink,omitempty"`
	Mirrorlist *string   `json:"mirrorlist,omitempty"`

	// Disables modularity filtering for this repository.
	ModuleHotfixes *bool   `json:"module_hotfixes,omitempty"`
	Name           *string `json:"name,omitempty"`
	Priority       *int    `json:"priority,omitempty"`
	RepoGpgcheck   *bool   `json:"repo_gpgcheck,omitempty"`
	Sslverify      *bool   `json:"sslverify,omitempty"`
}

// BlueprintUser defines model for BlueprintUser.
type BlueprintUser struct {
	Description *string `json:"description,omitempty"`

	// Group id to use instead of the default
	Gid *int `json:"gid,omitempty"`

	// A list of additional groups to add the user to
	Groups *[]string `json:"groups,omitempty"`

	// The user's home directory
	Home *string `json:"home,omitempty"`

	// ssh public key
	Key  *string `json:"key,omitempty"`
	Name string  `json:"name"`

	// If the password starts with $6$, $5$, or $2b$ it will be stored as
	// an encrypted password. Otherwise it will be treated as a plain text
	// password.
	Password *string `json:"password,omitempty"`

	// Login shell to use
	Shell *string `json:"shell,omitempty"`

	// User id to use instead of the default
	Uid *int `json:"uid,omitempty"`
}

// CACertsCustomization defines model for CACertsCustomization.
type CACertsCustomization struct {
	PemCerts []string `json:"pem_certs"`
}

// CloneComposeBody defines model for CloneComposeBody.
type CloneComposeBody interface{}

// CloneComposeResponse defines model for CloneComposeResponse.
type CloneComposeResponse struct {
	// Embedded struct due to allOf(#/components/schemas/ObjectReference)
	ObjectReference `yaml:",inline"`
	// Embedded fields due to inline allOf schema
	Id string `json:"id"`
}

// CloneStatus defines model for CloneStatus.
type CloneStatus struct {
	// Embedded struct due to allOf(#/components/schemas/ObjectReference)
	ObjectReference `yaml:",inline"`
	// Embedded struct due to allOf(#/components/schemas/UploadStatus)
	UploadStatus `yaml:",inline"`
}

// ComposeId defines model for ComposeId.
type ComposeId struct {
	// Embedded struct due to allOf(#/components/schemas/ObjectReference)
	ObjectReference `yaml:",inline"`
	// Embedded fields due to inline allOf schema
	Id string `json:"id"`
}

// ComposeLogs defines model for ComposeLogs.
type ComposeLogs struct {
	// Embedded struct due to allOf(#/components/schemas/ObjectReference)
	ObjectReference `yaml:",inline"`
	// Embedded fields due to inline allOf schema
	ImageBuilds []interface{} `json:"image_builds"`
	Koji        *KojiLogs     `json:"koji,omitempty"`
}

// ComposeManifests defines model for ComposeManifests.
type ComposeManifests struct {
	// Embedded struct due to allOf(#/components/schemas/ObjectReference)
	ObjectReference `yaml:",inline"`
	// Embedded fields due to inline allOf schema
	Manifests []interface{} `json:"manifests"`
}

// ComposeMetadata defines model for ComposeMetadata.
type ComposeMetadata struct {
	// Embedded struct due to allOf(#/components/schemas/ObjectReference)
	ObjectReference `yaml:",inline"`
	// Embedded fields due to inline allOf schema
	// ID (hash) of the built commit
	OstreeCommit *string `json:"ostree_commit,omitempty"`

	// Package list including NEVRA
	Packages *[]PackageMetadata `json:"packages,omitempty"`
}

// ComposeRequest defines model for ComposeRequest.
type ComposeRequest struct {
	Blueprint      *Blueprint      `json:"blueprint,omitempty"`
	Customizations *Customizations `json:"customizations,omitempty"`
	Distribution   string          `json:"distribution"`
	ImageRequest   *ImageRequest   `json:"image_request,omitempty"`
	ImageRequests  *[]ImageRequest `json:"image_requests,omitempty"`
	Koji           *Koji           `json:"koji,omitempty"`
}

// ComposeSBOMs defines model for ComposeSBOMs.
type ComposeSBOMs struct {
	// Embedded struct due to allOf(#/components/schemas/ObjectReference)
	ObjectReference `yaml:",inline"`
	// Embedded fields due to inline allOf schema
	// The SBOM documents for each image built in the compose.
	Items [][]ImageSBOM `json:"items"`
}

// ComposeStatus defines model for ComposeStatus.
type ComposeStatus struct {
	// Embedded struct due to allOf(#/components/schemas/ObjectReference)
	ObjectReference `yaml:",inline"`
	// Embedded fields due to inline allOf schema
	ImageStatus   ImageStatus        `json:"image_status"`
	ImageStatuses *[]ImageStatus     `json:"image_statuses,omitempty"`
	KojiStatus    *KojiStatus        `json:"koji_status,omitempty"`
	Status        ComposeStatusValue `json:"status"`
}

// ComposeStatusError defines model for ComposeStatusError.
type ComposeStatusError struct {
	Details *interface{} `json:"details,omitempty"`
	Id      int          `json:"id"`
	Reason  string       `json:"reason"`
}

// ComposeStatusValue defines model for ComposeStatusValue.
type ComposeStatusValue string

// Container defines model for Container.
type Container struct {
	// Name to use for the container from the image
	Name *string `json:"name,omitempty"`

	// Reference to the container to embed
	Source string `json:"source"`

	// Control TLS verifification
	TlsVerify *bool `json:"tls_verify,omitempty"`
}

// ContainerUploadOptions defines model for ContainerUploadOptions.
type ContainerUploadOptions struct {
	// Name for the created container image
	Name *string `json:"name,omitempty"`

	// Tag for the created container image
	Tag *string `json:"tag,omitempty"`
}

// ContainerUploadStatus defines model for ContainerUploadStatus.
type ContainerUploadStatus struct {
	// Digest of the manifest of the uploaded container on the registry
	Digest string `json:"digest"`

	// FQDN of the uploaded image
	Url string `json:"url"`
}

// CustomRepository defines model for CustomRepository.
type CustomRepository struct {
	Baseurl        *[]string `json:"baseurl,omitempty"`
	CheckGpg       *bool     `json:"check_gpg,omitempty"`
	CheckRepoGpg   *bool     `json:"check_repo_gpg,omitempty"`
	Enabled        *bool     `json:"enabled,omitempty"`
	Filename       *string   `json:"filename,omitempty"`
	Gpgkey         *[]string `json:"gpgkey,omitempty"`
	Id             string    `json:"id"`
	Metalink       *string   `json:"metalink,omitempty"`
	Mirrorlist     *string   `json:"mirrorlist,omitempty"`
	ModuleHotfixes *bool     `json:"module_hotfixes,omitempty"`
	Name           *string   `json:"name,omitempty"`
	Priority       *int      `json:"priority,omitempty"`
	SslVerify      *bool     `json:"ssl_verify,omitempty"`
}

// Customizations defines model for Customizations.
type Customizations struct {
	Cacerts    *CACertsCustomization `json:"cacerts,omitempty"`
	Containers *[]Container          `json:"containers,omitempty"`

	// Extra repositories for packages specified in customizations. These
	// repositories will be used to depsolve and retrieve packages. Additionally,
	// these packages will be saved and imported to the `/etc/yum.repos.d/` directory
	// on the image
	CustomRepositories *[]CustomRepository `json:"custom_repositories,omitempty"`
	Directories        *[]Directory        `json:"directories,omitempty"`

	// FIDO device onboard configuration
	Fdo        *FDO          `json:"fdo,omitempty"`
	Files      *[]File       `json:"files,omitempty"`
	Filesystem *[]Filesystem `json:"filesystem,omitempty"`

	// System FIPS mode setup
	Fips *FIPS `json:"fips,omitempty"`

	// Firewalld configuration
	Firewall *FirewallCustomization `json:"firewall,omitempty"`

	// List of groups to create
	Groups *[]Group `json:"groups,omitempty"`

	// Configures the hostname
	Hostname *string `json:"hostname,omitempty"`

	// Ignition configuration
	Ignition *Ignition `json:"ignition,omitempty"`

	// Name of the installation device, currently only useful for the edge-simplified-installer type
	InstallationDevice *string    `json:"installation_device,omitempty"`
	Installer          *Installer `json:"installer,omitempty"`
	Kernel             *Kernel    `json:"kernel,omitempty"`

	// Locale configuration
	Locale   *Locale   `json:"locale,omitempty"`
	Openscap *OpenSCAP `json:"openscap,omitempty"`
	Packages *[]string `json:"packages,omitempty"`

	// Select how the disk image will be partitioned. 'auto-lvm' will use raw unless
	// there are one or more mountpoints in which case it will use LVM. 'lvm' always
	// uses LVM, even when there are no extra mountpoints. 'raw' uses raw partitions
	// even when there are one or more mountpoints.
	PartitioningMode *CustomizationsPartitioningMode `json:"partitioning_mode,omitempty"`

	// Extra repositories for packages specified in customizations. These
	// repositories will only be used to depsolve and retrieve packages
	// for the OS itself (they will not be available for the build root or
	// any other part of the build process). The package_sets field for these
	// repositories is ignored.
	PayloadRepositories *[]Repository      `json:"payload_repositories,omitempty"`
	Rhsm                *RHSMCustomization `json:"rhsm,omitempty"`
	Rpm                 *RPMCustomization  `json:"rpm,omitempty"`
	Services            *Services          `json:"services,omitempty"`
	Subscription        *Subscription      `json:"subscription,omitempty"`

	// Timezone configuration
	Timezone *Timezone `json:"timezone,omitempty"`
	Users    *[]User   `json:"users,omitempty"`
}

// Select how the disk image will be partitioned. 'auto-lvm' will use raw unless
// there are one or more mountpoints in which case it will use LVM. 'lvm' always
// uses LVM, even when there are no extra mountpoints. 'raw' uses raw partitions
// even when there are one or more mountpoints.
type CustomizationsPartitioningMode string

// DNFPluginConfig defines model for DNFPluginConfig.
type DNFPluginConfig struct {
	Enabled *bool `json:"enabled,omitempty"`
}

// DepsolveRequest defines model for DepsolveRequest.
type DepsolveRequest struct {
	Architecture string        `json:"architecture"`
	Blueprint    Blueprint     `json:"blueprint"`
	Distribution string        `json:"distribution"`
	Repositories *[]Repository `json:"repositories,omitempty"`
}

// DepsolveResponse defines model for DepsolveResponse.
type DepsolveResponse struct {
	// Package list including NEVRA
	Packages []PackageMetadata `json:"packages"`
}

// A custom directory to create in the final artifact.
type Directory struct {
	// Ensure that the parent directories exist
	EnsureParents *bool `json:"ensure_parents,omitempty"`

	// Group of the directory as a group name or a gid
	Group *interface{} `json:"group,omitempty"`

	// Permissions string for the directory in octal format
	Mode *string `json:"mode,omitempty"`

	// Path to the directory
	Path string `json:"path"`

	// Owner of the directory as a user name or a uid
	User *interface{} `json:"user,omitempty"`
}

// Error defines model for Error.
type Error struct {
	// Embedded struct due to allOf(#/components/schemas/ObjectReference)
	ObjectReference `yaml:",inline"`
	// Embedded fields due to inline allOf schema
	Code        string       `json:"code"`
	Details     *interface{} `json:"details,omitempty"`
	OperationId string       `json:"operation_id"`
	Reason      string       `json:"reason"`
}

// ErrorList defines model for ErrorList.
type ErrorList struct {
	// Embedded struct due to allOf(#/components/schemas/List)
	List `yaml:",inline"`
	// Embedded fields due to inline allOf schema
	Items []Error `json:"items"`
}

// FIDO device onboard configuration
type FDO struct {
	DiMfgStringTypeMacIface *string `json:"di_mfg_string_type_mac_iface,omitempty"`
	DiunPubKeyHash          *string `json:"diun_pub_key_hash,omitempty"`
	DiunPubKeyInsecure      *string `json:"diun_pub_key_insecure,omitempty"`
	DiunPubKeyRootCerts     *string `json:"diun_pub_key_root_certs,omitempty"`
	ManufacturingServerUrl  *string `json:"manufacturing_server_url,omitempty"`
}

// System FIPS mode setup
type FIPS struct {
	// Enables the system FIPS mode
	Enabled *bool `json:"enabled,omitempty"`
}

// A custom file to create in the final artifact.
type File struct {
	// Contents of the file as plain text
	Data *string `json:"data,omitempty"`

	// Ensure that the parent directories exist
	EnsureParents *bool `json:"ensure_parents,omitempty"`

	// Group of the file as a gid or a group name
	Group *interface{} `json:"group,omitempty"`

	// Permissions string for the file in octal format
	Mode *string `json:"mode,omitempty"`

	// Path to the file
	Path string `json:"path"`

	// Owner of the file as a uid or a user name
	User *interface{} `json:"user,omitempty"`
}

// Filesystem defines model for Filesystem.
type Filesystem struct {
	// size of the filesystem in bytes
	MinSize    uint64 `json:"min_size"`
	Mountpoint string `json:"mountpoint"`
}

// Firewalld configuration
type FirewallCustomization struct {
	// List of ports (or port ranges) and protocols to open
	Ports *[]string `json:"ports,omitempty"`

	// Firewalld services to enable or disable
	Services *FirewallServices `json:"services,omitempty"`
}

// Firewalld services to enable or disable
type FirewallServices struct {
	// List of services to disable
	Disabled *[]string `json:"disabled,omitempty"`

	// List of services to enable
	Enabled *[]string `json:"enabled,omitempty"`
}

// Bind a list of network sources to a zone to restrict traffic from
// those sources based on the settings of the zone.
type FirewallZones struct {
	// name of the zone, if left empty the sources will apply to
	// the default zone.
	Name *string `json:"name,omitempty"`

	// List of sources for the zone
	Sources *[]string `json:"sources,omitempty"`
}

// GCPUploadOptions defines model for GCPUploadOptions.
type GCPUploadOptions struct {
	// Name of an existing STANDARD Storage class Bucket.
	Bucket *string `json:"bucket,omitempty"`

	// The name to use for the imported and shared Compute Engine image.
	// The image name must be unique within the GCP project, which is used
	// for the OS image upload and import. If not specified a random
	// 'composer-api-<uuid>' string is used as the image name.
	ImageName *string `json:"image_name,omitempty"`

	// The GCP region where the OS image will be imported to and shared from.
	// The value must be a valid GCP location. See https://cloud.google.com/storage/docs/locations.
	// If not specified, the multi-region location closest to the source
	// (source Storage Bucket location) is chosen automatically.
	Region string `json:"region"`

	// List of valid Google accounts to share the imported Compute Engine image with.
	// Each string must contain a specifier of the account type. Valid formats are:
	//   - 'user:{emailid}': An email address that represents a specific
	//     Google account. For example, 'alice@example.com'.
	//   - 'serviceAccount:{emailid}': An email address that represents a
	//     service account. For example, 'my-other-app@appspot.gserviceaccount.com'.
	//   - 'group:{emailid}': An email address that represents a Google group.
	//     For example, 'admins@example.com'.
	//   - 'domain:{domain}': The G Suite domain (primary) that represents all
	//     the users of that domain. For example, 'google.com' or 'example.com'.
	// If not specified, the imported Compute Engine image is not shared with any
	// account.
	ShareWithAccounts *[]string `json:"share_with_accounts,omitempty"`
}

// GCPUploadStatus defines model for GCPUploadStatus.
type GCPUploadStatus struct {
	ImageName string `json:"image_name"`
	ProjectId string `json:"project_id"`
}

// Group defines model for Group.
type Group struct {
	// Group id of the group to create (optional)
	Gid *int `json:"gid,omitempty"`

	// Name of the group to create
	Name string `json:"name"`
}

// Ignition configuration
type Ignition struct {
	Embedded  *IgnitionEmbedded  `json:"embedded,omitempty"`
	Firstboot *IgnitionFirstboot `json:"firstboot,omitempty"`
}

// IgnitionEmbedded defines model for IgnitionEmbedded.
type IgnitionEmbedded struct {
	Config string `json:"config"`
}

// IgnitionFirstboot defines model for IgnitionFirstboot.
type IgnitionFirstboot struct {
	// Provisioning URL
	Url string `json:"url"`
}

// ImageRequest defines model for ImageRequest.
type ImageRequest struct {
	Architecture string       `json:"architecture"`
	ImageType    ImageTypes   `json:"image_type"`
	Ostree       *OSTree      `json:"ostree,omitempty"`
	Repositories []Repository `json:"repositories"`

	// Size of image, in bytes. When set to 0 the image size is a minimum
	// defined by the image type.
	Size *uint64 `json:"size,omitempty"`

	// Options for a given upload destination.
	// This should really be oneOf but AWSS3UploadOptions is a subset of
	// AWSEC2UploadOptions. This means that all AWSEC2UploadOptions objects
	// are also valid AWSS3UploadOptionas objects which violates the oneOf
	// rules. Therefore, we have to use anyOf here but be aware that it isn't
	// possible to mix and match more schemas together.
	UploadOptions *UploadOptions `json:"upload_options,omitempty"`

	// The type and options for multiple upload targets. Each item defines
	// a separate upload destination with its own options. Multiple
	// different targets as well as multiple targets of the same kind are
	// supported.
	UploadTargets *[]UploadTarget `json:"upload_targets,omitempty"`
}

// ImageSBOM defines model for ImageSBOM.
type ImageSBOM struct {
	// The name of the osbuild pipeline which has the packages described
	// in the SBOM installed.
	PipelineName string `json:"pipeline_name"`

	// The purpose of the pipeline. The `buildroot` pipeline was used for
	// the build environment dueing the image build. The `image` pipeline
	// represents the actual content of the image. Due to the nature of
	// some image types, there may be multiple pipelines of the same
	// purpose.
	PipelinePurpose ImageSBOMPipelinePurpose `json:"pipeline_purpose"`

	// The SBOM document in the 'sbom_type' format.
	Sbom interface{} `json:"sbom"`

	// The type of the SBOM document. Currently only SPDX is supported.
	SbomType ImageSBOMSbomType `json:"sbom_type"`
}

// The purpose of the pipeline. The `buildroot` pipeline was used for
// the build environment dueing the image build. The `image` pipeline
// represents the actual content of the image. Due to the nature of
// some image types, there may be multiple pipelines of the same
// purpose.
type ImageSBOMPipelinePurpose string

// The type of the SBOM document. Currently only SPDX is supported.
type ImageSBOMSbomType string

// ImageStatus defines model for ImageStatus.
type ImageStatus struct {
	Error          *ComposeStatusError `json:"error,omitempty"`
	Status         ImageStatusValue    `json:"status"`
	UploadStatus   *UploadStatus       `json:"upload_status,omitempty"`
	UploadStatuses *[]UploadStatus     `json:"upload_statuses,omitempty"`
}

// ImageStatusValue defines model for ImageStatusValue.
type ImageStatusValue string

// ImageTypes defines model for ImageTypes.
type ImageTypes string

// ImportKeys defines model for ImportKeys.
type ImportKeys struct {
	Files *[]string `json:"files,omitempty"`
}

// Installer defines model for Installer.
type Installer struct {
	SudoNopasswd *[]string `json:"sudo-nopasswd,omitempty"`
	Unattended   *bool     `json:"unattended,omitempty"`
}

// Kernel defines model for Kernel.
type Kernel struct {
	// Appends arguments to the bootloader kernel command line
	Append *string `json:"append,omitempty"`

	// Name of the kernel to use
	Name *string `json:"name,omitempty"`
}

// Koji defines model for Koji.
type Koji struct {
	Name    string `json:"name"`
	Release string `json:"release"`
	Server  string `json:"server"`
	TaskId  int    `json:"task_id"`
	Version string `json:"version"`
}

// KojiLogs defines model for KojiLogs.
type KojiLogs struct {
	Import interface{} `json:"import"`
	Init   interface{} `json:"init"`
}

// KojiStatus defines model for KojiStatus.
type KojiStatus struct {
	BuildId *int `json:"build_id,omitempty"`
}

// List defines model for List.
type List struct {
	Kind  string `json:"kind"`
	Page  int    `json:"page"`
	Size  int    `json:"size"`
	Total int    `json:"total"`
}

// LocalUploadOptions defines model for LocalUploadOptions.
type LocalUploadOptions map[string]interface{}

// LocalUploadStatus defines model for LocalUploadStatus.
type LocalUploadStatus struct {
	ArtifactPath string `json:"artifact_path"`
}

// Locale configuration
type Locale struct {
	// Sets the keyboard layout
	Keyboard *string `json:"keyboard,omitempty"`

	// List of locales to be installed, the first one becomes primary, subsequent ones are secondary
	Languages *[]string `json:"languages,omitempty"`
}

// OCIUploadOptions defines model for OCIUploadOptions.
type OCIUploadOptions map[string]interface{}

// OCIUploadStatus defines model for OCIUploadStatus.
type OCIUploadStatus struct {
	Url string `json:"url"`
}

// OSTree defines model for OSTree.
type OSTree struct {
	// A URL which, if set, is used for fetching content. Implies that `url` is set as well,
	// which will be used for metadata only.
	Contenturl *string `json:"contenturl,omitempty"`

	// Can be either a commit (example: 02604b2da6e954bd34b8b82a835e5a77d2b60ffa), or a branch-like reference (example: rhel/8/x86_64/edge)
	Parent *string `json:"parent,omitempty"`
	Ref    *string `json:"ref,omitempty"`

	// Determines whether a valid subscription manager (candlepin) identity is required to
	// access this repository. Consumer certificates will be used as client certificates when
	// fetching metadata and content.
	Rhsm *bool   `json:"rhsm,omitempty"`
	Url  *string `json:"url,omitempty"`
}

// ObjectReference defines model for ObjectReference.
type ObjectReference struct {
	Href string `json:"href"`
	Id   string `json:"id"`
	Kind string `json:"kind"`
}

// OpenSCAP defines model for OpenSCAP.
type OpenSCAP struct {
	JsonTailoring *OpenSCAPJSONTailoring `json:"json_tailoring,omitempty"`

	// Puts a specified policy ID in the RHSM facts, so that any instances registered to
	// insights will be automatically connected to the compliance policy in the console.
	PolicyId  *string            `json:"policy_id,omitempty"`
	ProfileId string             `json:"profile_id"`
	Tailoring *OpenSCAPTailoring `json:"tailoring,omitempty"`
}

// OpenSCAPJSONTailoring defines model for OpenSCAPJSONTailoring.
type OpenSCAPJSONTailoring struct {
	Filepath  string `json:"filepath"`
	ProfileId string `json:"profile_id"`
}

// OpenSCAPTailoring defines model for OpenSCAPTailoring.
type OpenSCAPTailoring struct {
	Selected   *[]string `json:"selected,omitempty"`
	Unselected *[]string `json:"unselected,omitempty"`
}

// Package defines model for Package.
type Package struct {
	// Name of the package to install. File globbing is supported,
	// eg. 'openssh-*'
	Name string `json:"name"`

	// Optional version of the package to install. If left blank the
	// latest available version will be used. Wildcards are supported
	// eg. '4.11.*'
	Version *string `json:"version,omitempty"`
}

// PackageDetails defines model for PackageDetails.
type PackageDetails struct {
	Arch        string  `json:"arch"`
	Buildtime   *string `json:"buildtime,omitempty"`
	Description *string `json:"description,omitempty"`
	Epoch       *string `json:"epoch,omitempty"`
	License     *string `json:"license,omitempty"`
	Name        string  `json:"name"`
	Release     string  `json:"release"`
	Summary     *string `json:"summary,omitempty"`
	Url         *string `json:"url,omitempty"`
	Version     string  `json:"version"`
}

// PackageGroup defines model for PackageGroup.
type PackageGroup struct {
	// Package group name
	Name string `json:"name"`
}

// PackageMetadata defines model for PackageMetadata.
type PackageMetadata struct {
	Arch string `json:"arch"`

	// Optional package checksum using ALGO:HASH form
	Checksum  *string `json:"checksum,omitempty"`
	Epoch     *string `json:"epoch,omitempty"`
	Name      string  `json:"name"`
	Release   string  `json:"release"`
	Sigmd5    *string `json:"sigmd5,omitempty"`
	Signature *string `json:"signature,omitempty"`
	Type      string  `json:"type"`
	Version   string  `json:"version"`
}

// PulpOSTreeUploadOptions defines model for PulpOSTreeUploadOptions.
type PulpOSTreeUploadOptions struct {
	// Basepath for distributing the repository
	Basepath string `json:"basepath"`

	// Repository to import the ostree commit to
	Repository    *string `json:"repository,omitempty"`
	ServerAddress *string `json:"server_address,omitempty"`
}

// PulpOSTreeUploadStatus defines model for PulpOSTreeUploadStatus.
type PulpOSTreeUploadStatus struct {
	RepoUrl string `json:"repo_url"`
}

// RHSMConfig defines model for RHSMConfig.
type RHSMConfig struct {
	DnfPlugins          *SubManDNFPluginsConfig `json:"dnf_plugins,omitempty"`
	SubscriptionManager *SubManConfig           `json:"subscription_manager,omitempty"`
}

// RHSMCustomization defines model for RHSMCustomization.
type RHSMCustomization struct {
	Config *RHSMConfig `json:"config,omitempty"`
}

// RPMCustomization defines model for RPMCustomization.
type RPMCustomization struct {
	ImportKeys *ImportKeys `json:"import_keys,omitempty"`
}

// Repository configuration.
// At least one of the 'baseurl', 'mirrorlist', 'metalink' properties must
// be specified. If more of them are specified, the order of precedence is
// the same as listed above.
type Repository struct {
	Baseurl  *string `json:"baseurl,omitempty"`
	CheckGpg *bool   `json:"check_gpg,omitempty"`

	// Enables gpg verification of the repository metadata
	CheckRepoGpg *bool `json:"check_repo_gpg,omitempty"`

	// GPG key used to sign packages in this repository.
	Gpgkey     *string `json:"gpgkey,omitempty"`
	IgnoreSsl  *bool   `json:"ignore_ssl,omitempty"`
	Metalink   *string `json:"metalink,omitempty"`
	Mirrorlist *string `json:"mirrorlist,omitempty"`

	// Disables modularity filtering for this repository.
	ModuleHotfixes *bool `json:"module_hotfixes,omitempty"`

	// Naming package sets for a repository assigns it to a specific part
	// (pipeline) of the build process.
	PackageSets *[]string `json:"package_sets,omitempty"`

	// Determines whether a valid subscription is required to access this repository.
	Rhsm *bool `json:"rhsm,omitempty"`
}

// SSHKey defines model for SSHKey.
type SSHKey struct {
	// Adds the key to the user's authorized_keys file
	Key string `json:"key"`

	// User to configure the ssh key for
	User string `json:"user"`
}

// SearchRequest defines model for SearchRequest.
type SearchRequest struct {
	Architecture string `json:"architecture"`
	Distribution string `json:"distribution"`

	// Array of package names to search for. Supports * wildcards for
	// names, but not for versions.
	Packages     []string      `json:"packages"`
	Repositories *[]Repository `json:"repositories,omitempty"`
}

// SearchResponse defines model for SearchResponse.
type SearchResponse struct {
	// Detailed package information from DNF
	Packages []PackageDetails `json:"packages"`
}

// Services defines model for Services.
type Services struct {
	// List of services to disable by default
	Disabled *[]string `json:"disabled,omitempty"`

	// List of services to enable by default
	Enabled *[]string `json:"enabled,omitempty"`

	// List of services to mask by default
	Masked *[]string `json:"masked,omitempty"`
}

// SubManConfig defines model for SubManConfig.
type SubManConfig struct {
	Rhsm      *SubManRHSMConfig      `json:"rhsm,omitempty"`
	Rhsmcertd *SubManRHSMCertdConfig `json:"rhsmcertd,omitempty"`
}

// SubManDNFPluginsConfig defines model for SubManDNFPluginsConfig.
type SubManDNFPluginsConfig struct {
	ProductId           *DNFPluginConfig `json:"product_id,omitempty"`
	SubscriptionManager *DNFPluginConfig `json:"subscription_manager,omitempty"`
}

// SubManRHSMCertdConfig defines model for SubManRHSMCertdConfig.
type SubManRHSMCertdConfig struct {
	AutoRegistration *bool `json:"auto_registration,omitempty"`
}

// SubManRHSMConfig defines model for SubManRHSMConfig.
type SubManRHSMConfig struct {
	ManageRepos *bool `json:"manage_repos,omitempty"`
}

// Subscription defines model for Subscription.
type Subscription struct {
	ActivationKey string `json:"activation_key"`
	BaseUrl       string `json:"base_url"`
	Insights      bool   `json:"insights"`
	Organization  string `json:"organization"`

	// Optional flag to use rhc to register the system, which also always enables Insights.
	Rhc       *bool  `json:"rhc,omitempty"`
	ServerUrl string `json:"server_url"`
}

// Timezone configuration
type Timezone struct {
	// List of ntp servers
	Ntpservers *[]string `json:"ntpservers,omitempty"`

	// Name of the timezone, defaults to UTC
	Timezone *string `json:"timezone,omitempty"`
}

// Options for a given upload destination.
// This should really be oneOf but AWSS3UploadOptions is a subset of
// AWSEC2UploadOptions. This means that all AWSEC2UploadOptions objects
// are also valid AWSS3UploadOptionas objects which violates the oneOf
// rules. Therefore, we have to use anyOf here but be aware that it isn't
// possible to mix and match more schemas together.
type UploadOptions interface{}

// UploadStatus defines model for UploadStatus.
type UploadStatus struct {
	Options interface{}       `json:"options"`
	Status  UploadStatusValue `json:"status"`
	Type    UploadTypes       `json:"type"`
}

// UploadStatusValue defines model for UploadStatusValue.
type UploadStatusValue string

// UploadTarget defines model for UploadTarget.
type UploadTarget struct {
	Type UploadTypes `json:"type"`

	// Options for a given upload destination.
	// This should really be oneOf but AWSS3UploadOptions is a subset of
	// AWSEC2UploadOptions. This means that all AWSEC2UploadOptions objects
	// are also valid AWSS3UploadOptionas objects which violates the oneOf
	// rules. Therefore, we have to use anyOf here but be aware that it isn't
	// possible to mix and match more schemas together.
	UploadOptions UploadOptions `json:"upload_options"`
}

// UploadTypes defines model for UploadTypes.
type UploadTypes string

// User defines model for User.
type User struct {
	Groups *[]string `json:"groups,omitempty"`
	Key    *string   `json:"key,omitempty"`
	Name   string    `json:"name"`

	// If the password starts with $6$, $5$, or $2b$ it will be stored as
	// an encrypted password. Otherwise it will be treated as a plain text
	// password.
	Password *string `json:"password,omitempty"`
}

// Page defines model for page.
type Page string

// Size defines model for size.
type Size string

// PostComposeJSONBody defines parameters for PostCompose.
type PostComposeJSONBody ComposeRequest

// PostCloneComposeJSONBody defines parameters for PostCloneCompose.
type PostCloneComposeJSONBody CloneComposeBody

// PostDepsolveBlueprintJSONBody defines parameters for PostDepsolveBlueprint.
type PostDepsolveBlueprintJSONBody DepsolveRequest

// GetErrorListParams defines parameters for GetErrorList.
type GetErrorListParams struct {
	// Page index
	Page *Page `json:"page,omitempty"`

	// Number of items in each page
	Size *Size `json:"size,omitempty"`
}

// PostSearchPackagesJSONBody defines parameters for PostSearchPackages.
type PostSearchPackagesJSONBody SearchRequest

// PostComposeJSONRequestBody defines body for PostCompose for application/json ContentType.
type PostComposeJSONRequestBody PostComposeJSONBody

// PostCloneComposeJSONRequestBody defines body for PostCloneCompose for application/json ContentType.
type PostCloneComposeJSONRequestBody PostCloneComposeJSONBody

// PostDepsolveBlueprintJSONRequestBody defines body for PostDepsolveBlueprint for application/json ContentType.
type PostDepsolveBlueprintJSONRequestBody PostDepsolveBlueprintJSONBody

// PostSearchPackagesJSONRequestBody defines body for PostSearchPackages for application/json ContentType.
type PostSearchPackagesJSONRequestBody PostSearchPackagesJSONBody

// ServerInterface represents all server handlers.
type ServerInterface interface {
	// The status of a cloned compose
	// (GET /clones/{id})
	GetCloneStatus(ctx echo.Context, id string) error
	// Create compose
	// (POST /compose)
	PostCompose(ctx echo.Context) error
	// The status of a compose
	// (GET /composes/{id})
	GetComposeStatus(ctx echo.Context, id string) error
	// Clone an existing compose
	// (POST /composes/{id}/clone)
	PostCloneCompose(ctx echo.Context, id string) error
	// Get logs for a compose.
	// (GET /composes/{id}/logs)
	GetComposeLogs(ctx echo.Context, id string) error
	// Get the manifests for a compose.
	// (GET /composes/{id}/manifests)
	GetComposeManifests(ctx echo.Context, id string) error
	// Get the metadata for a compose.
	// (GET /composes/{id}/metadata)
	GetComposeMetadata(ctx echo.Context, id string) error
	// Get the SBOMs for a compose.
	// (GET /composes/{id}/sboms)
	GetComposeSBOMs(ctx echo.Context, id string) error
	// Depsolve one or more blueprints
	// (POST /depsolve/blueprint)
	PostDepsolveBlueprint(ctx echo.Context) error
	// Get a list of all possible errors
	// (GET /errors)
	GetErrorList(ctx echo.Context, params GetErrorListParams) error
	// Get error description
	// (GET /errors/{id})
	GetError(ctx echo.Context, id string) error
	// Get the openapi spec in json format
	// (GET /openapi)
	GetOpenapi(ctx echo.Context) error
	// Search for detailed information on a list of package names
	// (POST /search/packages)
	PostSearchPackages(ctx echo.Context) error
}

// ServerInterfaceWrapper converts echo contexts to parameters.
type ServerInterfaceWrapper struct {
	Handler ServerInterface
}

// GetCloneStatus converts echo context to params.
func (w *ServerInterfaceWrapper) GetCloneStatus(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "id" -------------
	var id string

	err = runtime.BindStyledParameterWithLocation("simple", false, "id", runtime.ParamLocationPath, ctx.Param("id"), &id)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter id: %s", err))
	}

	ctx.Set(BearerScopes, []string{""})

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.GetCloneStatus(ctx, id)
	return err
}

// PostCompose converts echo context to params.
func (w *ServerInterfaceWrapper) PostCompose(ctx echo.Context) error {
	var err error

	ctx.Set(BearerScopes, []string{""})

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.PostCompose(ctx)
	return err
}

// GetComposeStatus converts echo context to params.
func (w *ServerInterfaceWrapper) GetComposeStatus(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "id" -------------
	var id string

	err = runtime.BindStyledParameterWithLocation("simple", false, "id", runtime.ParamLocationPath, ctx.Param("id"), &id)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter id: %s", err))
	}

	ctx.Set(BearerScopes, []string{""})

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.GetComposeStatus(ctx, id)
	return err
}

// PostCloneCompose converts echo context to params.
func (w *ServerInterfaceWrapper) PostCloneCompose(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "id" -------------
	var id string

	err = runtime.BindStyledParameterWithLocation("simple", false, "id", runtime.ParamLocationPath, ctx.Param("id"), &id)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter id: %s", err))
	}

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.PostCloneCompose(ctx, id)
	return err
}

// GetComposeLogs converts echo context to params.
func (w *ServerInterfaceWrapper) GetComposeLogs(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "id" -------------
	var id string

	err = runtime.BindStyledParameterWithLocation("simple", false, "id", runtime.ParamLocationPath, ctx.Param("id"), &id)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter id: %s", err))
	}

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.GetComposeLogs(ctx, id)
	return err
}

// GetComposeManifests converts echo context to params.
func (w *ServerInterfaceWrapper) GetComposeManifests(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "id" -------------
	var id string

	err = runtime.BindStyledParameterWithLocation("simple", false, "id", runtime.ParamLocationPath, ctx.Param("id"), &id)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter id: %s", err))
	}

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.GetComposeManifests(ctx, id)
	return err
}

// GetComposeMetadata converts echo context to params.
func (w *ServerInterfaceWrapper) GetComposeMetadata(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "id" -------------
	var id string

	err = runtime.BindStyledParameterWithLocation("simple", false, "id", runtime.ParamLocationPath, ctx.Param("id"), &id)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter id: %s", err))
	}

	ctx.Set(BearerScopes, []string{""})

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.GetComposeMetadata(ctx, id)
	return err
}

// GetComposeSBOMs converts echo context to params.
func (w *ServerInterfaceWrapper) GetComposeSBOMs(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "id" -------------
	var id string

	err = runtime.BindStyledParameterWithLocation("simple", false, "id", runtime.ParamLocationPath, ctx.Param("id"), &id)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter id: %s", err))
	}

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.GetComposeSBOMs(ctx, id)
	return err
}

// PostDepsolveBlueprint converts echo context to params.
func (w *ServerInterfaceWrapper) PostDepsolveBlueprint(ctx echo.Context) error {
	var err error

	ctx.Set(BearerScopes, []string{""})

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.PostDepsolveBlueprint(ctx)
	return err
}

// GetErrorList converts echo context to params.
func (w *ServerInterfaceWrapper) GetErrorList(ctx echo.Context) error {
	var err error

	ctx.Set(BearerScopes, []string{""})

	// Parameter object where we will unmarshal all parameters from the context
	var params GetErrorListParams
	// ------------- Optional query parameter "page" -------------

	err = runtime.BindQueryParameter("form", true, false, "page", ctx.QueryParams(), &params.Page)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter page: %s", err))
	}

	// ------------- Optional query parameter "size" -------------

	err = runtime.BindQueryParameter("form", true, false, "size", ctx.QueryParams(), &params.Size)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter size: %s", err))
	}

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.GetErrorList(ctx, params)
	return err
}

// GetError converts echo context to params.
func (w *ServerInterfaceWrapper) GetError(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "id" -------------
	var id string

	err = runtime.BindStyledParameterWithLocation("simple", false, "id", runtime.ParamLocationPath, ctx.Param("id"), &id)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter id: %s", err))
	}

	ctx.Set(BearerScopes, []string{""})

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.GetError(ctx, id)
	return err
}

// GetOpenapi converts echo context to params.
func (w *ServerInterfaceWrapper) GetOpenapi(ctx echo.Context) error {
	var err error

	ctx.Set(BearerScopes, []string{""})

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.GetOpenapi(ctx)
	return err
}

// PostSearchPackages converts echo context to params.
func (w *ServerInterfaceWrapper) PostSearchPackages(ctx echo.Context) error {
	var err error

	ctx.Set(BearerScopes, []string{""})

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.PostSearchPackages(ctx)
	return err
}

// This is a simple interface which specifies echo.Route addition functions which
// are present on both echo.Echo and echo.Group, since we want to allow using
// either of them for path registration
type EchoRouter interface {
	CONNECT(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	DELETE(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	GET(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	HEAD(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	OPTIONS(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	PATCH(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	POST(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	PUT(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	TRACE(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
}

// RegisterHandlers adds each server route to the EchoRouter.
func RegisterHandlers(router EchoRouter, si ServerInterface) {
	RegisterHandlersWithBaseURL(router, si, "")
}

// Registers handlers, and prepends BaseURL to the paths, so that the paths
// can be served under a prefix.
func RegisterHandlersWithBaseURL(router EchoRouter, si ServerInterface, baseURL string) {

	wrapper := ServerInterfaceWrapper{
		Handler: si,
	}

	router.GET(baseURL+"/clones/:id", wrapper.GetCloneStatus)
	router.POST(baseURL+"/compose", wrapper.PostCompose)
	router.GET(baseURL+"/composes/:id", wrapper.GetComposeStatus)
	router.POST(baseURL+"/composes/:id/clone", wrapper.PostCloneCompose)
	router.GET(baseURL+"/composes/:id/logs", wrapper.GetComposeLogs)
	router.GET(baseURL+"/composes/:id/manifests", wrapper.GetComposeManifests)
	router.GET(baseURL+"/composes/:id/metadata", wrapper.GetComposeMetadata)
	router.GET(baseURL+"/composes/:id/sboms", wrapper.GetComposeSBOMs)
	router.POST(baseURL+"/depsolve/blueprint", wrapper.PostDepsolveBlueprint)
	router.GET(baseURL+"/errors", wrapper.GetErrorList)
	router.GET(baseURL+"/errors/:id", wrapper.GetError)
	router.GET(baseURL+"/openapi", wrapper.GetOpenapi)
	router.POST(baseURL+"/search/packages", wrapper.PostSearchPackages)

}

// Base64 encoded, gzipped, json marshaled Swagger object
var swaggerSpec = []string{

	"H4sIAAAAAAAC/+x9eXMiObL4V1Hwm4ieec19GOyIiX0YX/i2wXbbS4dXVAmQqZKqJRUYz+vv/gsddUFx",
	"tbtndnb7j91pUzpSKWUqb/2RsajrUYKI4Jm9PzIeZNBFAjHz1xDJ/9qIWwx7AlOS2ctcwyECmNjoNZPN",
	"oFfoeg5KNJ9Ax0eZvUwp8/VrNoNlny8+YrNMNkOgK7+oltkMt0bIhbKLmHnydy4YJkPVjeO3lLkvfbeP",
	"GKADgAVyOcAEIGiNgBkwDk0wQAhNsbgUHtV2FTxfg49q6OZD57BVbjmUoJZEH1cTQdvGEkzoXDPqISaw",
	"BGQAHY6yGS/20x8ZhoZqPQsTZTN8BBl6nmIxeoaWRX2zMWZlmb1/ZkrlSrW2U2/sFkvlzOdsRmEidSzz",
	"A2QMztTaGfriY4ZsOYyB4XPYjPZfkCVkP72+O8+h0L5SqOffvMAQ8Azyc1PERa6Uyf6Zy85mOIEeH1Hx",
	"rHc7DpM7ywVfF6FKR1g6rOvQ2BFQ+JpKEoiCLk5CBF2cK1qNSrG+W6nXa7Xdml3tp2FsSxTPLUbOm11z",
	"BjqV9xwBz+872NIkPIC+I8J2SZJuDwBHAggK1GfwqxghYLoARby/ZQEEDiXDLKD9gc8tKJAN7m7PewRz",
	"wJDwGUF2HrQFB+jVwwzKoYGLhyMB+ghwSgliQIwgAQPKABUjxICv1tYjArIhEjzfIz0SwSKYj+S0fESZ",
	"QEzOBmKTAUjsHsHJCTEHEnYOXQQgV1PJv+PTgWi2aIv6lDoIkvdv6mbbuewo+sxJZ8XxKWSj1PHffIbe",
	"c1xGMw+x58nzEBGk8Zk4Opl7ufzkyWmNKOVI4fj+ArRdeS+dyGHuQTRKFth4MEAMEQEGCAqfIQ4oAQpg",
	"AOX/JhA7sO+gHrGRh4iNyVC2kOMuDKc3DhHfldhQQN2XYxiJ6BNLeEKWM3eNySNCB2oKfTCQDVQHeYqB",
	"63N1cH2Cv/jyrlUNh3iCCGCIU59ZCAwZ9b28OrNyEnn6qIuFJI0Bo67qIncOcSEPMoPEpi6gBIE+5MiW",
	"K4Tg7q59ADDvEbNCZJsFxjmkAiyNBTnUiu1UfIHn5kuwSI/RCZaLDMB/VuBnwXSEmN5CNYukN9+x1eID",
	"vEAiuw0xF4gp+E7oVJKog7kA0HFAAAbf65GREB7fKxRsavG8iy1GOR2IvEXdAiI5nxcsBxeg3PuC4d3/",
	"mGA0/V39lLMcnHOgQFz8P/gWMPdnOdFzOMkHhXIJcfCTRD2hAnAPWXiAkZ0FWMgfbWT7VmJDluBhHumS",
	"3pEv6SOd88f7rj5dyeOyAbrnQelS34Lk1gxzrGZMu7/9fgjCM7YXgWofSJDizb4BmCqq2Y1+2crBfrma",
	"q1ZLldxu0arldkrlSnEHNYq7qJwGnUAEErECLgmEbrQZVOYIDjCx1V5rCtU85ZoyAZ1NzmJwDgWeoJyN",
	"GbIEZbPCwCc2dBER0OELX3MjOs0JmpNT5zTIc0iqWXU0qPV3ciWrMshVbVjMwZ1yOVfsF3eK5cquXbfr",
	"a6+SCGOLe7twAtdcCMsunCSH3ITlzAEZGyANhH3HRx7DRGx5FVmUCIiJUYLm7pzgmz4dXJ4C5PYl+yZS",
	"bBgheSigAyATA2hJqTIUVH9haJDZy/y/QqRzFYxWUQjHTRNgLZ8L6uI3GF6sq4YKl91Kdvs6d3+mSM42",
	"5oLRxVV3pUgmv+G+r0hXUOBzFIo4ltaC8qA9AA4aCIBcT8zUpxHlokf0wGCKHUdREl+k7QGyKYO5ym4a",
	"AatzxtN0UWssiVR/l2D15X3JBXQcZG+KfDOKZm4p+Hep7RutMjl9kwDoYCPreXoUnpVSotxLW/3ch9Z4",
	"CpnNFZaggH3sYDFTq98GujTAAtpZwFcAy1KMvRdXadBMEOOp0kATcOROEAOmBSBKjU9sfz1fz9eLa0l+",
	"PbG3FohlG9KHFmJiPbU2W7JZYipNP5pL4zTMH0QfJfIthqAIhbuQaeBtuEYw5CxtOwY2Xdf/6OBKtcSp",
	"p/tI/vy9QA33R46aCq6cbcYFclPESSnq0QGI2gBXimYexUTEQPwmYMykqSCl8ZxDIpUFcNS+7gCX2ihV",
	"kRtghqbQcbaAxHQIuN1yLETMbrtVL+VvkkenKyotSgZ4qHSmgJmrhmn6zpDg4GJZBUU7aKdscYr7KPp5",
	"ttEEW2uUpXgHoDtkgeUzqd45M0CJM5OXy8B3wrsJ2UOU49j1HCWb5wKOx4BcwtwlVLDRpMBtmLrAoOPa",
	"FYYNv2YzY8QIWnsMznQro1M5aF37c93qazZDPUS4Bb2ND9qVh0in1bzW1wQTajMwGT6rs5zQuaEvaM6Z",
	"uAuadwc5yBJgJKVgLRqMjbQc3PDhyMjOgw/BQB/0dyk6MDgFPnEQ5z0ilMgtdXGpnlIGXMpQgsKx1Baw",
	"NQIW5EhK3OE45/cXefBBjQ2dKZzxHvE54vL3LEBSY56OkGJcZgpCAXoVDMbHz4MPDE4/ANVTQhaCz3sk",
	"bZAlcCatAwxOM9mMxl+Iys+pCp1HOV52b9zGvkqinzIskPxHAQmrMPPdvOqftwtJDm3sCZdUIIliKOQ3",
	"HiBBKCEMQAH6PnZsILCL8psLJeFxCqFLvYPYiLvrhro96Vws3KTMW9/verEbR0zyhLXgd4J2sg8fjdFs",
	"ObvlfATGaMY3RU2nc3KGUrEhcfxGyVrq7gbtvmYzPtcMJx02+fU9998dT9M4vq6Sr9T9nSLiaSVFXdHr",
	"ZAZ9zpKSlw0FTFe3JOQB/1ejQw48B8qR0atYqi0sDqbuv/mRIBhiW9IyNCYSc79FdwKjyjlACboaZPb+",
	"uShth79gItBQIvSzVhrSnGeIuZhLIZgDPUB4USmIMAHUElBdXy4UCUCKO9Vq2nI9KEZpgr4YgVAldZJr",
	"UqzDnZnfF0ZMP3RXU6J9b0n8+QH+ZK/vhL45qV+t8PO6UxlJj8mj5WKS7k2Uv8bXY0RLTEB/JhCPL6Nc",
	"qtarjcpOtZHNvOaGNGdA8TERO1WtJAbXQNKaUZhAtlatiXXOhvCuWXAkYK5UcOZlet3NBpYR7TTvXPDe",
	"UKMGpfMd9Rn8KrVeygRgkAwR/02Zaj1GBbWoo9iSlE7iaPxnplzeE5aXyWYaRfMP7EJP/XM7p96GnD5Y",
	"cJzjS96qLVCbMMtghCfVaztmGQpbC4dS8jsuGIJu6nJfOCXPAmKHql/WgBhMc9q5uuyGnSRroA62ZqmG",
	"z2tfSOoNjdZAtwXtg4Bpy4sZSH7Ns4BLRgIFgGSmhXBiSVEpNMsDQXtEntvhSPBQCpRSjwsFtqDjzOSJ",
	"I0jZww1bkitxsBwqmNzMbFHCqWPkEcMJ9zK+r4yPi/yPUUm9ZpWLJ2dbLMYwOM+HoplWEmdMKFrY+D7k",
	"yGdO8vxF7CIwGls2yTNkj6A2GFv6IizYmIsCGyGnUWgUXhs7zzvVghyR8gLlhQS2GE41hc/REVLabBxz",
	"CS3WQUttTENvaI2QNU7vOvSGSmiKr3ItMEt20EUCOpiM0zHlYsYo43ltQPQYlduRp2xYCPr9QwrIvwcG",
	"xnLPLxbLO5BZo981BjdAm57EwVwsAhHCID/nLUQE5Wr+fzDkIMjR742cJvXYzFD+/05V/6Lg24ccXXU2",
	"gUWZI59HVAzwa7qlictN5UC1hAyLmbzfBIrJG8qZHZzSZe7o5fZFhqkcNvYxvL21PvO8+nhw7kwQw4NZ",
	"2ud5M/8aarsz0soWdr51hvBhGsfU8iO2A+u35IMI2oEEEejN2RSMLLNfN7UXkw5ABHzMvgNtW/uIpWQl",
	"aFy8j46gal7ahNZHNM3G0zUTfOBANgChqyltyFRNSWpIOtxDKkoJ6Y/zUQ7Z5VqttAuazWazVbl8g62S",
	"83TQLl12D2vyt/YlOz47ZBeP+OPFxd3UP4G3zVP39py2324H5S8HZfug9lbc774Wdl7TYFr0IMnllNJF",
	"Zc6nlKX5AY2j2jQAXECmbjIxAr/s/JIFv9R+yUo595dy/5fQAtFHgAsq7z/IewQSgIjFZp6844KR8uBK",
	"jBCb4pjhoo+AUPqRrUXoSJ3pkbBfnCbjgVJIC33zDvchJkB9NMczVa5PO9aSfL7lVG9qmU81lm8ZS4Tc",
	"59AwHxMmc7nc/uFx+xK0Dm+77aN2q9k9zOVyvR65aLdbxYNWq9nHw+a0vd8ctu/a+Xy+1yO5XO7w8mCu",
	"yzsC6SLgUlcfixLcp7ainkgXWiWOpEQZKsUy/sst4h4lJv7QcTYY9UpBdotUSIyFlP4155a1k8RUKldQ",
	"tbZTz6HGbj9XKtuVHKzWdnLV8s5OrVatFovF4noxbROeHq4u8hh/+6JWtU/4pfW0Gp9t+z8Ik3pJ53TI",
	"v+uilNNdGQ1TpTsDQlJNlkyDDaCF/viadjGN6QteayKnL1itJT0KwAC0EhUXkOAB4uK74sOND/p+ZMwb",
	"BsLRV68MCRhY0L7XwqiUWdGzRV0Xi9TAmV9HkI9+C24KuQMCmObZb/BJa1kIE8vxVQze5eH9bXNLv3SI",
	"iA309Bj+bnWg3NpriVChw5ujHZoLzshm+mHYyeev8xdZPx6SspGFdvv4j5Swj1joRpIjSU0y18gsDV9k",
	"EV5Werxk4wCH8503t7TMD/OtbGKBihIIiG17Z//q4vsyx2CZiyK2nAvY1PJdZdCWWphKXdB+M008oflD",
	"h9PEz/5GA0Zhosb5cxjN4HNfWWFGSlIVQGqmAogpVQPxrPJpBYNonxAiE8wokeMr016sRY9AS/jQAcYw",
	"ETpo1bybEq3acDl9qrdkFV/Uw6/kid9DiEi7+ng47vqlGQkjm+iKtqSIaJQ0gtgQHkkX0UCb9Ukg8l7l",
	"0czvgxkoucBN9uWQMcpSzKJIQKyMY/PmoIR9AfJUxX1RNAobLwCg1yO5oXHXct+yEJdrGUDs+ExqUCYc",
	"XC4optOGDRe4ZhTGt7CyFZHgC9F0QYxhGDe8NARbx2GmOY3NMY5srcGgQcRi0kujLLlsljc/KaOjmnVP",
	"wGGqccHhz5EJZ9Ftx6gDuucdoNrgAbYCR0M4qcqxWGf8MQtMVa2CJb0n72DFtoT7YVR1Kxn7ORc6Qrli",
	"mqmogsMUFg6HW86gI9NTFYJ1uInxwi2MZHho7v5586L8PeD4gYS6kM8QLcYkUwRnLN2wYdJP5txVNweX",
	"6YkSc7j54sNZHtOCOzNR+wWzH3srsDaf2JINlpx62pRYtYFl/9/EsK+Mr89Db5hugNWfA0ttept3+QaM",
	"pfCn8f+HG/+/m92ec+f5vVb5vzL8Nhm4/73i7p9Xh2cdqmCyeJtENHjMwYoJSGpyedAdIY56JNE7HiQv",
	"L2sbeZw6E2QSoQTDaILC8fOgGeLXmWVVMB2PPkdmajgxuVTY9SiLeWH/tRBH9q/IB9AjhnlHTHczvM5z",
	"yxT0zkVL/yURzxtGAGwSsrzxUOsDjleO0L7ubBNhHIQvLFDLMp/Uv1WYcTwr6Gf08d82+jgZdBzZAWO+",
	"HI9yMWSIbxcG9DOC+d8igtmDMymc/yVXpSK7je/LHglI86oDsODIGaiSAzM9GKEq8zrMCZ+ziDFKBaCs",
	"RyCZmcR+iei4CVxFwFmI898UzMHEzxwJDgYYOXYw5sJyMAd4SCgLkuM2Yrf/AQHYsfzStf3ibd8RUr35",
	"5b95iPTB5dG14w8x0dfZooK4Qp9KHc8c5E2dE3OVRZg1wgJZwmdz0RGh3rNAxt/mnvgW98I8o3j3UZ/T",
	"TqKVzMGXTSLmcwLPkTN9Lv7gL3ddJaOhDTRp+lckIC+P0Q+l+28J1EeE+ww9e5AFRaNW13c5VO1BkIAC",
	"dEcQE/4BesVxC008inCDSP5oNTqcP4ziN1H92P5LwvkjsFbG9NdrtW+L6Y+HaS0E9tuYfWNc/xw2w5h+",
	"E+L/PZC5aXB/6CL4Xv4by+zhYt573Osge8BYHYsU3rWZ+8HSyaGm+dzA6S4SteRzY2jabNmq9QpP5EYs",
	"SKP6PU43qVhvmYrQPrgyWhSgpE8hW5eUYONndzB81uh+lkA8u9B6lqxqyb5inzx7fv95jGbPI8hH61th",
	"wpFlrszVLeXZj6LSFg11kPiSh/oKWCkXIfa8tMbSwuFXav52CO3o9JUwMRlwJFS1lqVSyDrOraOIVVGr",
	"ubEz2Y1EmL9BstgPvM/WeLp+Jqr99ySqrclPe/67Jag9L81QS7c3/sxS2zJL7esK1HZio34TVgOwVCyA",
	"LmdBGbB12kjKtctjN0ZqinRsvGiUGD4FcggS2+EucU+tm1U3Tk46EHLjiPC2DO5eivenIG9wC6TvY2ID",
	"GKZ5ECSmlI2BDmvQSR7gjRJ1DTIkobIEEAwOBthS8R89IkaUo7BHWL1PXctICEyG4ZUnR0q7MNPN7iRm",
	"25Y9swAv1G8KplXWMeh5zkyl+sWLdEaTLglPWUGiwfDB3aJsNEvD3np+sVixdB/1b/TPgv7NhXysf/n8",
	"f/qXi2ZL//B/2ONI7Olf1b/17+ud6Gln4bh1/Z5wk75vjZFY7maAREsP8r7tdJuXB83bA9ARlMEhApYD",
	"OQf7aoj8fJVG80fOzLBlRcruCGk1by4WKXQWSqapCt/aoEVdzxcIHJIhJkHIX490w5J5aqC5IpZTLEZG",
	"vjtuXQPjqc8aozjmynybNM7qsEVdNzVyXKoiY4lyi2F1yx75YEInWQ56OKe33PexrXf8QyDJmOmkWCAS",
	"UG9T/TKq1bqISrlE/T1WTzBcU+BiiHtiY/iVVG/wqerfhqiE8m9sq9GD4pN50EEIhMElDvXt/JDSoQnh",
	"4vroqBqEhbCGpSkbmqxZqYJ5fEfgnIE8rG9pOZQjLgIhzdAf+dWUlgyOpz6YYbffJJotybtIMhF4HsnI",
	"36IidDobMXhR6wZBcwmvGiV5ktOOrzqe+R5R8bLmkCism5CCWKJ0KFiaaZQjLw/uFQRaGOYAMrTXIwDk",
	"wAcpbO79gVyIHWx//bAHmgSovwC0bYY416oEQx5DXKkv4VyWHALMLSsPjigDBntZ8AE62EL/Gwvb+5A3",
	"M5v7san7bQmDntoMsWxud5ZTTpAc9Lz/hZ7HPSryQ9Mp6BMHSWku22LDrD+olCrhmkOB7WLCU3FgUxdi",
	"sveH/q+cUJEn6PhYIKB/Bb96DLuQzX5bnNxx9IRBFqa5aaEwfecxEpHeBylSfZiDKZ3qVh/NoLqsZg4q",
	"IRGSWY8E+O3Nya7qwC2cikwojAbnYdPNyxg9dW8RzZlsxiA4/uMPqUkf3rvfr5qoupvl+M/ziVqQW4jY",
	"kIhcn0Fs5yrFSq1UWaskxYbLritOehyo/lsID6uzkg1b0saByKjyK/X08L+lZiavL1A9N+C3l2hsx2I0",
	"tpCgg25rdEEV02xrfWGTCJDDoL2OpeGiT6nYtPNR2CFVSFyYY+sCtMZ/uM7ArNqtwvVRfGVbgJAajXvN",
	"6ARzHWwB7m7PNwqqTYUunujz492amhT1zxvkW3RnnnZM6wy4tbEtna5s9SOcmvFnUIxNsrhg9TU2IrXI",
	"bGgbyoOHESLBcwbFeEFr2QHLi9XFBLu+2yM2Gqh6tf1ZrJ2Sa5KXS7W8W93dqZd3d5YZmbS4/ky9jVLV",
	"kppU1N28kpAuW8s5dTqS7qd0FSW4eg6af2fBZEAJ5AK9SN4jEHDkQSaZo2ltI6lxaWFXXbBYcECnJJgi",
	"Dy7M+D0SPSdg5pBaxBRJ7ZhHYATfDA9Vb0KMlSmAoR7hvqdv/C3iPDSuumrctRdpgkoSBDB3Sj8H1Kiy",
	"sBYd39hDDiZrtUazTBNzD4JuRrsbGT0rDPTRo/Slwmd0QpXMFhYjzqde1gEsns+CN3cWwTEfw4cHTCcd",
	"i/MvBR6jVPwrBiM02uCAMm3YWMx+s30keV5EHKqJGVT9Eg2ognoCAVIrCssz5cCBH6boEPU6BaCDHuHU",
	"jZMhz5rILReqUKfwmAVzJg5ajxgk5GOhXOHKg+OQGsfF+9TdINsw8NR8kO3VufpgVJ/Yzm2S+xz2X0Hq",
	"ZmUJAPKglQy77FwffJJMLaKs2Nq5Z7+mLHc+06ivpeQQpOzc8U85ghH5LJFKUeDD3jjPLnTFbp1naDL0",
	"Qi662QDJWghznbe4x+bHWcmfgjzBJPq2SsnL6iOt/6mB1v8OipKZvL2FMx6742NTwamcBk55bgRzbORj",
	"81fsnxx64Z9vGhj9bAiCXj3xJflHrJ8KBw5T5M1fQQaC+SGK9M1mhsr3MLTCAYZSZAoVGvXfRAdMRU6K",
	"e7DvJIeWH8KJ9R/Jj/OjMDiN5qEiNYg5k804eJKEQAkV0Mnp2FFqSagn3JPsK/pXjk5gJpuZcmfJFkki",
	"PjP1w5IUtRi6/w1W3HY8mjo5PvdtmiNUleGxt8tg8gkUAhF78xC/szA+exsR2JM0kOJWV79zANnQ5ISb",
	"i0UeCJU7x4AOCFdVGqQIJZlZwhZHKHfF7wPKLLSq1NJybdFMENYgiobWX3I26vvDzZIYz0y+/zekc0bT",
	"HunMr5ZDfTu3D/kSW67K1Ur2LBfLxeJusZ4vptonVURHelbamL7glJQ0+fPI72+SzAf5eN4qUS2n6e+x",
	"RxciOCrr3woz4EdTmc2NRoyw8nnJ3gSlZeYNMZJ4TQY3UaVDFgKJiGZDuuWy4ZfdqYrvb4KdtDMVBFcl",
	"h5Si+ZKHNIZoSbKc0cwWvwgqoJP2aQ4LatJs+BimfoNSd84ujbXKqre1nO18UKvGWPoyoYm/eQ6iNtY8",
	"KJhovhRutKXxR3daY/oZo5kKH1vkTB1kZPCgCXDgjPrJcBU/NZXfgWTopwf9Bl4HnS2z8JRK1sRrMNmK",
	"INBHFnURB8bKnFWvYKEvvlIGpOwOGQIcWZTY0GRHx8y5iDzfdfJ33aNc471+7KtW+53nJhzhhzwiaCwp",
	"e3+kPMiEiEi1STXV04xKz1Tua45ENvTvDSgDAySskVTezCh50JaCDDKehn/5zPmX0hyQCDT5bI9oxTWR",
	"iqnMDCZGWykdS3zeOiAsJTwNEjkWwiptBJpKSeBXs9d7oFjeKVb7ZRvuoN1atW9Xqv1Gv1GGjUoN1WC9",
	"bpf7O8XBAP6W1WFMfQaJNco5eIwAC+s9ROOxEXKiZHIpW/4253lbbJF+OQ4Ww/o36GZST1aH0x0ggZir",
	"VNjpCBnUaHde4rE4FxI4RAz8akFiO8jD5DeAbUQEFjP9Mqc+Xyo6ASq1YaHKKWhRwn0XMWDJw6VqUswn",
	"3EIOLAdL0ky2GSHSI+FZCs+BFKKCg7WkiOrmMZ/zEcwLhDAyW7Fo4Uy/vZZca2llUsxlpGZIpc2llax/",
	"lqr+G5aqTt+GVGVryf2/ZjHLwclGo66CbAVUXCVvoq21s2/pl0anwRto363STGCsNMlEggbCRB4cYQeB",
	"oUP7fRO4Elq4sj2ChnnwQeXg8lHufz7McXfh+qn1cpe+03ZlPIXhO20r4Ape+us7kIx1RTBdaSWWOxkM",
	"k3j2Dzxgx7bUg3hK7gmWY1ZTzZdK+YWlVPIV+O2OR7NfB2GWR4pPKfUoKE1DYHdZ1sjqItLIo0vGdbCF",
	"TKLZUhV7lY6a8vyqK0XL1G/p90/iGGyA1zS9UOfSrUL5t3i50+kk8dLjYvA2JFDJzzlBqcPffVTi9TQ3",
	"PCuqoA733RVkFdBR0BT4XBJ18/z4au+k2TlRNvRk+ewRLNd29mrlWr3RsFHFtqvV6m7dKtftaqleru00",
	"Kjs7/XKx0ijCnf5OvVgfFGFpt16s1iuoast/7MDqIDXvYenp/LYTiIeuXVv2Sbs2VrDb95xPY6xfe0zl",
	"9vqOp7WMdwVxQo7Scxn2zRelLER5p8Z1FImiK1NiZyveAFMpm9puYjxugiEU6BKqRPwSS9WzCbBS1/pK",
	"89N8Km2w2lR6mUPoMr1QFZraSDkMW6ZNp1LVl2RX22Tw7Kn8a75BFvkFJGG+NjdDzr9jbXSOzUYLxvi6",
	"DOz5fIhlMR9rU/VXTXS9bh59dp6DtzlWu5ZCK3z6ZJsd2ITtJt8jzaD2qCpBoSWMD6Z22ocs+BCV01J/",
	"mTJeH0C0DhWa2SN9FKkESiBRxSz0iK4WLpJxdpTZOnzTY8hCtlKXsa7eoT30kKtAfakG9ukkNZI+VuTt",
	"z6vttnUtt80S+4be0JRnTL7WH3GiUNFdottGdd7mgtKuj8EYzcKaHPIKiNz/SnVKquaJWy+XCwv7Xx9f",
	"g+u7/fN2C5wdPoL986vWmfrcIz3i3rQv94+bVsei+4fNg/NB4/FkjN5Od6DtXDxO6/D4uO2cQkc0Tl/K",
	"r4X98tnHUXvQ9l+PhXf/Ukc9cn47PLir77zAbs27P6i5RxenFW+MCLotWF33y5eb8eXsho8+lenNp+nh",
	"212nX2pdXrQGrePh+FPjptwjb09j1rZa7Kh4U56ys74DfXt09xHfQ9I84G6p8Xj4hfdrzbtK3RZ37KJy",
	"82g/DHdvP37C14P7xm2PnO2/dIuVyf3+lX3R4Y+V3XPYIjttr3Q18RrtQ1poo8P7x9IXt3V13YRnxf7p",
	"ScUfDKstH435x26nR6Y3D13UOn/1n853ri4+0avrs+nk4mbw2h+WPh00Jv5T8Uy8FKzLk/Ir9IuvLm/6",
	"uyenHhpPrq5vX50emX0RL7OnAaP3GB3NvOnTcHIzFYRcNArDzqFfOL3vssdirewe3nXrLatfr46tk6Pu",
	"0eBi7JDxcaFHioO7avMW1orVk8rrS3Es+qgyObOuP9HrK/9s/56fdCbF4t3xY3N2jfzZx0bduis8Ho4u",
	"6uNK5/7spUd2UPtpOMMXV8WpU3o8Prg9s3xnOua7zY++Mx6WaLdf5ZU392lyXawf0+7rQ7X8As9qD52P",
	"l6MnhHqksVP8RO9Hfat05nU+vgye6Atnh+Kpcd2/e/r4ODlq3HrMfmiyl5P+6bh86t2eNV+7o1d+0+T7",
	"o+NSjxTP/dfyA7zYLw7L7dq1dWGfFqwvL7TYsCz2sv/Jx68PDNewv3vxyWt86RYGnbdLl9vtIWkUvjyd",
	"9Qhu3PjOwK/X/S+jh8JUlPuCYDG85V9eRq8X/svjXfWpXx2NxVFjdHZX+PSpXi1/GZ3XzqbN2+ZNc79H",
	"xMHR8dPD7cRyD4dnBxels06z8eTej/uV09F596J0/ml/Bh9KI4s4zeB36+R0At37F7tVm/SI5Vof8c3p",
	"1f7+xX6r2awe4cNDdLLjstHRSd2/5zfnFxfl4mPNehqR18fGUdNVNNQ6njaOWtNxu0f2p+3joxt62mry",
	"1v7+Y6s5PWydDA9bR9VmszUc30S9P14+Ngv1/Udv6Mw6zafHk9HL7GzUI4WPg52368H9pH9SLh5+qYzb",
	"9auj/csiOf/0cf+u5PqTzscvXb9TeThn+xW3cuw7wju7PTw9Oxdu7fCgR0rs+O1Tk3ZLM2/3sd04bx7Y",
	"F63W1eyl+cLpw12j/njntz4W+uSFddFt+fz2qjWYXbfqOw+7jRq+uu8Rt9b52Oc3B9N6q3zOHLt5Ub04",
	"8OnsqdTB4hg+Vc9uzu/Fx+4hLFUxf+wct17eaP36sXFfOb0a14o9MvzyMGyULwt9t3z41ql3G5WHw4N+",
	"yZm8VNvO5HXY/nKGhqXS26fHV5c9dp5OT1uDydvgo3PZ2fFfhyc98vJaOC3OnKfyOe4fs53jZnN2tXv3",
	"wJpPnWnnonhovXQb08MWeR13DvzZF/dhej+53P/kH7bvG1eo8tgjF/iuNDi9bHC7fuDxo9faxcdPNrkg",
	"N52PJ+yle312UHEfmNO0yWF3ZD/eN16ext7D6GDGK4XdXXTVI6NxkZ2TWfHlcjqG/qCA7xpX1s6nycX4",
	"5fz24nRYu9u9P5ud+g8P4m36ibxcXNYebo/2v5xV+RN1Ly56ZCD63ZPSx9qsf/tQaFYm+334evtQFvW7",
	"t8sX6w2NO0+HGJ5f7p4XTqzTVvu2dHPU2GmUD+ymc3i0a/fIuDy8wY+dmyaEp8XT0+bbyeR2fHt6fj48",
	"Kz/ePOKTy/tZWVROZ0cDzqBbm3ZaD1eD0TVqz873u0+nPTJh3qVz3UcD3t2t1buD8v5l2x++PbFW7f71",
	"oHM2fhrejkr3x5NO+4a0Zm/jm9nO4V35y7WHH2q7kkeNrtufntgZtc4qZ+ed3QJ+O73p3jri5aL5e4/8",
	"fj3o1tXzMPqBmBVXz5IKdJShZ86d9Ev6Zx3T9Y+YrXQUfK9HzeIFuVLtcXK8QFXXVbuUuyUmFUEuBRoO",
	"lMoVy9dRxcB65NcgTuy31MJgCxkbQeFoumXxu+/rYUk6UcASH8qGhR/MI8jb6dWpomTTtkMXbmCNN8+V",
	"QV+MKMNvyFb6zGL1gI1eH2t2HrAYX51U7xr16qHN9+/ITPQr/enkdjg8cW6c/uMnp05KxcnuksrVqUUI",
	"7vSbbaH6o7PQzGPS8kgl7Ve2i8n6eHquQjYkntK04w6S9PjnxdV/S+Gv5aW0mvJYK+3M0B6Brnauc7Uu",
	"ibM86Gh7MQf/A6ahIVlF7qrmWdD3hcqXkkRrbEF8Lsx6PWH94OpkIRLWFycL9nT70mTa3K1eotP4xEQz",
	"ZUns6mWBg8ujLWuUBSb0d5Uo27h8wXcoQwD6s9gTdill2YMyunb6hUnaukvpu9QnWAsNGajITb41MC7k",
	"401hkW3XQqIrNmyLldSrIG4eWzQMblCgUo8Qt33pu89CTNhbdJbNV1nPlpgFF2mOUdsP0wZXlqueKwn5",
	"jRbGhWGWQz+/0EUHhi/os3mKAc75rlZf6fO7sJfyFJp+98mjfItRE160OWAtgSe6ZpoRDhKJnRxZDImc",
	"fnQ0lDjDRz7TKlxCjp5T7XeL5rsNpNggjCAx3LJqT5QNIYkZZuORptVipVxNj6Kx1ot4oYdp4MBhUMKB",
	"jSxdVEQHPsTKeAVVF6DDqak5bBgUB22zojkhddmaknXN4m/kRNual7QaQ+xavM5dJgm8ZefPRAKG2AbH",
	"NiftEurGCsduEY8YdFsTkUiEp6FaET1IhAeCRgl1oJgnlIlRDrqIYQvmPUqdPBGeVMcy2Uxp1eet9Id4",
	"8dzlUQlBq2xwYahL5K7bSgiwd53CIZTnjGwW273ofyOzjR9Fnc8bXNunU9muy0KVl7VzvPkMbddlyfNF",
	"67qlhP+u67IQ97muwzI36dfP6ZwnUJH123OLSZWqmgnmgI+o79iAIRVk1VdVyK8GSmRf3CSdo6piZYVK",
	"ikvZ+zxQ47oIEhPPCR0HpDQE+uTxHoEMacanVeCFeWHY1nDJCaYqskW7kCTAPcJ8B+ma5AwNKENZMEVg",
	"BCdh/Rx1moHK2ZOr6yMApzAoG4gFwJx8ED3iUc5xXxdBdPGrCid0obBG2pdl9gMIOlSKu2TKIe0sc7XG",
	"cm+3eWh4Ln9rY5LasMd8/YYtCGrDHulPXm1MGxu2X+Lw3oJq488Ob5+iFyb5bZLObnKGdT77spf7TPhE",
	"cGw+zx2wLZPymE/Issy7RArzwrndekHvzDZPjyKZG/Lz0qtreQZhnlfC1L0gUTCebUctnDcsRldOkgj0",
	"HS9v6g2YZzjSUWhsTdtUDQnfeUlR89TH0ibviS3I3z+f9n/f0/4b6CubRa0pMdzyGRazjjzqetv3EWT6",
	"rPTVv46C6U4fulJoVi2lMK/bhaNKXSjz9atSbgY0LaVGl4QS1Fi1VWk2HRaqU9Z5PpMIcdSbmGl60Boh",
	"UFbpdEphCL0f0+k0D9Vn5XIwfXnhvN06vOwc5sr5Yn4kXEcLrUIdhKvOvpreJE8zoGqfAejhWBDYXqYc",
	"PFMjP+xlKvlivpTRpWgVmgqWQwnihT+w/VVRS1p1vmOko600z1R1+oBhdPLcqOBwJIKnCbVxDYbP+Brh",
	"R78OELPCU6YMlVFRAVVgB1MCFItFts5iD8uGt20NSvyJfJVuAl0klKrxz5RHuoPSIAHwgoKhqg+IiTp7",
	"YhTEzu0FD6YGJ04rfZp9/pCX7D/L2bRlU21GuViM5fuYXFfHRKcUXkzV9QigleJADEvqOCcxE8eJPCLV",
	"7zi1SeFfnLRNtNBpTgbAtp669OOnbvqqyvIYKUcP1oDo2Ss/fvY7Evlq5An0EJNnA4RnW0NS/TMgGRM6",
	"JXNbUPszdv+OoFdPZ5WoshCAWurxMDvBwhUVB8z7n58ljYTR3aooRpwJKeYVnic1TiH4Q9VHTnu/taUL",
	"g0FA0DTomgUelUvHQfoLN0VIle14ghgMmLvi90bFUw+Ya58cZnGFjy8yrmvKheHVhskgLvapPft+FJ98",
	"y/9r8vqUzOzrAr8pfe/Z23ba1puPqhKOEj+Q/ZcxHRY9sP+T8/zkPBtyHsM00jjN9xKetpCXAhyuEZTi",
	"dXU2E5XCgf/LhKUEplJOUBIvPwWmn2zrbyowLeVfWhGMS00p8otsEgkxG/CTGLP6N+IiP0D2imFGDfxn",
	"S1+x+cNgmZQjpSoWomlUWrmvCvvp0rZLZDKBXkVB2XGS8MyjdmPuVf1eE6TR5tfErS3RknhUYAUBOKac",
	"z7fc4gNMMB/FLnGw8g7HIrq6s0qjUC4ZFwmYCFOCfeoLk5PCfUesuuZVNaKfl/zaS17haQlpyCMQvv2g",
	"vXmhgogJIFS/K2z5DmSm4iP4VYyoPxwZf9pp5+ryt/x/HCEdq4cNhoGjMzjlaWTkQoIHiIv1tBS23ICc",
	"bpHwGeEqaS7op4BROrhhZ8SQiuLvpvZt2NiiirDCqnBm+4Lav1CAuDnWlHLVIeiQFMzfuWC4fG0FKV6E",
	"KPhJj2vpMULWEqJMbPcCYf5n0lqSPDYguljC/mqaCys4SZJboDP97Ap6hZZIXERMkR+ygY10kUWaoLXQ",
	"9K+KZq+ijADOn4SxnjDCB5GX0EWwldvQxU8l9aeS+u+mpC7wpvX8jvepu1zACIQFCHTsVLJ4Nl8jN/TI",
	"XHPIwjaqznZU6nupyW3/6mLLy1/CpAOuNJsDwRj/JaY3tdolnE59/G+7/qNFz5OCbR7sL0Sv/K802wQP",
	"/O+HzX+MESSYZysPVPEHTL/c/hG0ibKCHBz4gv7EqzLYwZ/OqMUL8+9yawVHSddxYTpiNaRIHWBXUIPH",
	"L6qFGyN68n7hukhbWdSkoAonLwu8jLVTlZV/KA+P1pB25MLHXw0yfp71v0Y41Af97ycaRq8HQ8cBYch4",
	"cJoiMlvvh4UkLIkaeCc0ZFFt1f4MKBkonVA393og0/xd4lvlTxbGlm6l+gDiv/2k4p9UvA0Vo8UTJCk3",
	"DE1dfkNemSbvPPfzUcMLCzWgKF4g9T05hNH1/o7a9MrlSNTrsgKFeAb9ch1C5+FfR4n7P0KBSBZw+JPV",
	"h7lKAymbo1uAAAIdQR/oEXZUGuBPVSV4ANRPReJvqkh0wvIe5hAhO2F7pyQmAiWKg2iAwkzbBWnkwrzu",
	"rNL11ZPk4bM3yQQE6OG8qqM9wgOd/A09XNDPaym/F2K54Gn5wqSstI452hBwiMlw1QRcwCF65zSWfvbO",
	"vD4dTrNunM9f/38AAAD//+eM6+Xq2QAA",
}

// GetSwagger returns the content of the embedded swagger specification file
// or error if failed to decode
func decodeSpec() ([]byte, error) {
	zipped, err := base64.StdEncoding.DecodeString(strings.Join(swaggerSpec, ""))
	if err != nil {
		return nil, fmt.Errorf("error base64 decoding spec: %s", err)
	}
	zr, err := gzip.NewReader(bytes.NewReader(zipped))
	if err != nil {
		return nil, fmt.Errorf("error decompressing spec: %s", err)
	}
	var buf bytes.Buffer
	_, err = buf.ReadFrom(zr)
	if err != nil {
		return nil, fmt.Errorf("error decompressing spec: %s", err)
	}

	return buf.Bytes(), nil
}

var rawSpec = decodeSpecCached()

// a naive cached of a decoded swagger spec
func decodeSpecCached() func() ([]byte, error) {
	data, err := decodeSpec()
	return func() ([]byte, error) {
		return data, err
	}
}

// Constructs a synthetic filesystem for resolving external references when loading openapi specifications.
func PathToRawSpec(pathToFile string) map[string]func() ([]byte, error) {
	var res = make(map[string]func() ([]byte, error))
	if len(pathToFile) > 0 {
		res[pathToFile] = rawSpec
	}

	return res
}

// GetSwagger returns the Swagger specification corresponding to the generated code
// in this file. The external references of Swagger specification are resolved.
// The logic of resolving external references is tightly connected to "import-mapping" feature.
// Externally referenced files must be embedded in the corresponding golang packages.
// Urls can be supported but this task was out of the scope.
func GetSwagger() (swagger *openapi3.T, err error) {
	var resolvePath = PathToRawSpec("")

	loader := openapi3.NewLoader()
	loader.IsExternalRefsAllowed = true
	loader.ReadFromURIFunc = func(loader *openapi3.Loader, url *url.URL) ([]byte, error) {
		var pathToFile = url.String()
		pathToFile = path.Clean(pathToFile)
		getSpec, ok := resolvePath[pathToFile]
		if !ok {
			err1 := fmt.Errorf("path not found: %s", pathToFile)
			return nil, err1
		}
		return getSpec()
	}
	var specData []byte
	specData, err = rawSpec()
	if err != nil {
		return
	}
	swagger, err = loader.LoadFromData(specData)
	if err != nil {
		return
	}
	return
}
